story/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('story6.urls')),
    path('story8/', include('story8.urls')),
    path('story9/', include('story9.urls')),
]

story6/urls.py
from django.urls import path
from . import views

app_name = "story6"

urlpatterns = [
    path("",views.index,name="home"),
    path("add_peserta/<int:id>",views.add_peserta,name="add_peserta"),
    path("profile/<str:nama>",views.detail_peserta,name="detail_peserta"),
    path("add_kegiatan/",views.add_kegiatan, name="add_kegiatan"),
    path("delete_peserta/",views.delete_peserta, name="delete_peserta")
]

story8/urls.py
from django.urls import path
from . import views

app_name = 'story8'

urlpatterns = [
    path('', views.index, name='index'),
    path('get_books/', views.get_books, name='get_books'),
]

story9/urls.py
from django.urls import path

from . import views

app_name = 'story9'

urlpatterns = [
    path('register/', views.register, name='register'),
    path('login/', views.log_in, name='login'),
    path('logout/', views.log_out, name='logout')
]

story6/models.py
from django.db import models
from django.shortcuts import reverse

class Peserta(models.Model):
    nama_peserta = models.TextField(max_length=50, unique=True)

    def __str__(self):
        return self.nama_peserta
    
    def get_absolute_url(self):
        nama_url = self.nama_peserta.replace(" ","-")
        return reverse("story6:detail_peserta",args=[nama_url])

class Kegiatan(models.Model):
    nama_kegiatan = models.TextField(max_length=50,unique=True)
    peserta = models.ManyToManyField(Peserta,blank=True)

    def __str__(self):
        return self.nama_kegiatan

story8/models.py
from django.db import models

# Create your models here.

story9/models.py
from django.db import models

# Create your models here.

story6/forms.py
from django import forms
from .models import Kegiatan, Peserta

class FormPeserta(forms.ModelForm):
    nama_peserta = forms.CharField(widget=forms.TextInput(attrs={"class":"form-control w-40",
        "placeholder" : "Peserta Name"
    }), label = "")
    class Meta:
        model = Peserta
        fields = "__all__"

class FormKegiatan(forms.ModelForm):
    nama_kegiatan = forms.CharField(widget=forms.TextInput(attrs = {"class":"form-control w-50 text-center",
        "placeholder" : "Nama Kegiatan"
    }), label = "")
    class Meta:
        model = Kegiatan
        exclude = ["peserta"]

story9/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm

class RegistrationForm(UserCreationForm):
    username = forms.CharField(label="Username", widget=forms.TextInput(attrs={
        "class" : "form-control mb-3",
        "placeholder" : "Username"
    }))

    password1 = forms.CharField(label="Password", widget=forms.TextInput(attrs={
        "class" : "form-control mb-3",
        "placeholder" : "Password",
        "type" : "password"
    }))

    password2 = forms.CharField(label="Confirm Password*", widget=forms.TextInput(attrs={
        "class" : "form-control mb-3",
        "placeholder" : "Confirm Password",
        "type" : "password"
    }))

    class Meta:
        model = User
        fields = ["username", "password1", "password2"]

class LoginForm(AuthenticationForm):
    username = forms.CharField(label="Username", widget=forms.TextInput(attrs={
        "class" : "form-control mb-3",
        "placeholder" : "Username"
    }))

    password = forms.CharField(label="Password", widget=forms.TextInput(attrs={
        "class" : "form-control mb-3",
        "placeholder" : "Password",
        "type" : "password"
    }))

    class Meta:
        fields = "__all__"

story6/views.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404, reverse
from .models import Peserta, Kegiatan
from django.contrib import messages
from .forms import FormKegiatan, FormPeserta

def index(request):
    context = {
        "kegiatan_items" : Kegiatan.objects.all(),
        "peserta_form" : FormPeserta,
    }
    return render(request,"index.html",context)

def add_peserta(request,id):
    if request.method == "POST":
        kegiatan = Kegiatan.objects.get(id=id)
        nama_peserta_baru = request.POST["nama_peserta"]

        peserta_baru, status_baru = Peserta.objects.get_or_create(nama_peserta=nama_peserta_baru)
        if status_baru:
            peserta_baru.save()
            kegiatan.peserta.add(peserta_baru) # Add peserta baru yang tidak pernah ada.
            messages.add_message(request, messages.SUCCESS, "{} berhasil ditambahkan ke {}".format(nama_peserta_baru,kegiatan.nama_kegiatan))
        else:
            try:
                kegiatan.peserta.get(nama_peserta=nama_peserta_baru) # Jangan add peserta yang sudah di kegiatan.
                messages.add_message(request, messages.WARNING, "{} sudah di kegiatan {}".format(nama_peserta_baru,kegiatan.nama_kegiatan))
            except:
                kegiatan.peserta.add(peserta_baru) # Add peserta baru yang ada di database tapi tidak di kegiatan.
                messages.add_message(request, messages.SUCCESS, "{} berhasil ditambahkan ke {}".format(nama_peserta_baru,kegiatan.nama_kegiatan))
    return redirect(reverse("story6:home"))

def detail_peserta(request,nama):
    nama = nama.replace("-"," ")
    peserta = get_object_or_404(Peserta,nama_peserta=nama)
    context = {
        "peserta" : peserta
    }
    return render(request,"detail.html",context)

def add_kegiatan(request):
    if request.method == "POST":
        kegiatan_form = FormKegiatan(request.POST)
        if kegiatan_form.is_valid():
            kegiatan_object = kegiatan_form.save(commit=False)
            kegiatan_form.save()
        return redirect(reverse("story6:home"))

    context = {
        "kegiatan_form" : FormKegiatan,
        "is_add_kegiatan" : True
    }
    return render(request,"add_kegiatan.html",context)

def delete_peserta(request):
    if request.method == "POST":
        try:
            peserta = Peserta.objects.get(nama_peserta = request.POST["nama"])
            kegiatan = Kegiatan.objects.get(id = request.POST["kegiatan_id"])
        except:
            messages.add_message(request, messages.WARNING, "{} tidak ditemukan {} sebagai partisipan.".format(request.POST["nama"], request.POST["kegiatan_id"]))
            return redirect("story6:home")
        kegiatan.peserta.remove(peserta)
        messages.add_message(request, messages.SUCCESS, "{} berhasil dihapus dari {}.".format(peserta.nama_peserta, kegiatan.nama_kegiatan))
    return redirect("story6:home")

story8/views.py
from django.shortcuts import render
from django.http import JsonResponse
import urllib3
import json

def index(request):
    return render(request, 'story8/spellbook.html')
    
def get_books(request):
    http = urllib3.PoolManager()
    response = http.request(
        "GET", "https://www.googleapis.com/books/v1/volumes?q=" + request.GET.get('q', ''))
    return JsonResponse(json.loads(response.data.decode('utf8')))

story9/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
from django.contrib.auth import login , logout, authenticate
from django.contrib.auth.models import User
from .forms import RegistrationForm, LoginForm, AuthenticationForm

# Login System
def register(request):
    if request.user.is_authenticated:
        return redirect("story7:index")
    context = {
        "registering":RegistrationForm,
    }

    if request.method == "POST":
        registering = RegistrationForm(request.POST)
        if registering.is_valid():
            registering.save()
            new_user_account = authenticate(
                username = registering.cleaned_data['username'],
                password = registering.cleaned_data['password1']
            )
            login(request, new_user_account)

            return redirect("story8:index")
        elif registering.errors:
            context["error"] = "Wrong input!"
    return render(request, 'story9/register.html', context)

def log_in(request):
    context = {"login": LoginForm}
    if request.user.is_authenticated:
        return redirect("story8:index")

    if request.method == "POST":
        logging_in = LoginForm(data = request.POST)
        if logging_in.is_valid():
            user_account = logging_in.get_user()
            login(request, user_account)
            return redirect("story8:index")
        elif logging_in.errors:
            context["error"] = "Wrong Username or Password"
    return render(request, 'story9/login.html', context)

def log_out(request):
    if request.user.is_authenticated:
        logout(request)
    return redirect("story8:index")

story6/templates/add_kegiatan.html
{% extends "base.html" %}
{% block content %}

<div>
    <form class="mt-5 d-flex justify-content-center align-items-center flex-column" action="{% url 'story6:add_kegiatan' %}" method="POST">
        <h3>Add your Own Kegiatan :)</h3>
        {% csrf_token %}
        {{kegiatan_form}}
        <input class="btn btn-secondary mt-2" type="submit" value="Add Kegiatan">
    </form>
</div>

{% endblock %}

story6/templates/base.html
{% load static %}
<html lang="en">

<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <!-- Bootstrap CSS -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">

  <title>Hello, world!</title>
</head>

<body style="background-color:#002141;" class="textile text-light">
  {% include 'navbar.html' %}
  <div class="container pt-3">

      {% if messages %}
        {% for message in messages %}
          <div class="alert alert-{{message.tags}} alert-dismissible fade show mx-2" role="alert">
              {{message}}
              <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
          </div>
        {% endfor %}
      {% endif %}


    {% block content %}
    {% endblock %}
    </div>
    <p class="mt-2"style="text-align: center;"> by haydar </p>
    <!-- Optional JavaScript -->
  <!-- jQuery first, then Popper.js, then Bootstrap JS -->
  <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</body>

</html>

story6/templates/detail.html
{% extends 'base.html' %}
{% block content %}
<div class="card text-white mt-3 mx-auto" style="max-width: 50rem;background-color:#001427;">
  <div class="card-header"><h4>{{peserta.nama_peserta}}</h4></div>
  <div class="card-body">
    <div class = "rounded bg-dark p-2">
    <h5 class="card-title">Jumlah Partisipasi ({{peserta.kegiatan_set.all|length}}):</h5>
    {% for kegiatan in peserta.kegiatan_set.all %}
    <div class="d-flex flex-row justify-content-between my-1 py-2 rounded bg-light text-dark">
      <h4 class="card-text text-dark my-auto ml-2">{{kegiatan.nama_kegiatan}}</h4>
    </div>
    {% endfor %}
    </div>
  </div>
</div>
{% endblock %}

story6/templates/index.html
{% extends "base.html" %}
{% block content %}
    <div class="d-flex flex-wrap mx-auto">
    {% for kegiatan in kegiatan_items %}
        <div class="card text-white mb-3 mx-3" style="max-width:20rem; background-color:#001427;">
        <h5 class="card-header">{{kegiatan.nama_kegiatan}}</h5>
        <div class="card-body d-flex flex-column justify-content-between">
          <h5 class="card-title">Peserta:</h5>
          <form action="{% url 'story6:delete_peserta' %}" method="POST">
            {% csrf_token %}
            <input type="hidden" value={{kegiatan.id}} name="kegiatan_id">
            {% for peserta in kegiatan.peserta.all %}
            <div class="d-flex flex-row justify-content-between my-1 rounded bg-light">
            <h4 class="card-text text-light my-auto">-<a href="{{peserta.get_absolute_url}}">{{peserta.nama_peserta}}</a></h4>
            <button class="btn btn-danger my-2 mr-1" value="{{peserta.nama_peserta}}" name="nama" type="submit">X</button>
            </div>
            {% endfor %}
          </form>
          <form class="d-flex flex-row"action="{% url 'story6:add_peserta' id=kegiatan.id %}" method="POST">
            {% csrf_token %}
            {{peserta_form}}
            <input class="btn btn-primary ml-1" type="submit" value="Add Peserta"> 
          </form>
        </div>
      </div>
    {% endfor %}
    </div>
{% endblock %}

story6/templates/navbar.html
  <nav class="navbar navbar-dark sticky-top" style="background-color:#001427;box-shadow: 0px 5px 10px black;">
    <a class="navbar-brand text-light" href="{% url 'story6:home' %}">Event Organizer</a>
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link btn btn-light text-dark" style="min-width:8rem" href="{% url 'story6:add_kegiatan' %}">Add</a>
      </li>
    </ul>
  </nav>

story8/templates/story8/spellbook.html
<!doctype html>
{% load static %}
<html lang="en">

<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

  <!-- Bootstrap CSS -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <link href="https://fonts.googleapis.com/css2?family=Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap"
          rel="stylesheet">
  <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" />
  <link rel="stylesheet" href="{%static 'story8/animations.css'%}"/>
  <title>BookSearch</title>
</head>

<body>
  <nav class="shadow navbar navbar-expand-lg navbar-dark justify-content-between sticky-top" style="background-color:rgba(39,54,74,0.2)">
    <a class="navbar-brand text-light">Spellbook Library</a>
    <div class="d-flex flex-row">
    {% if request.user.is_authenticated %}
      <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search" id="search-query">
      <button class="btn btn-outline-light my-2 my-sm-0" id="search">Search</button>
      <a class="btn btn-warning-light my-2 ml-2 my-sm-0" href="{% url 'story9:logout' %}">Logout</a>
    {% elif not request.user.is_authenticated %}
      <a class="btn btn-success my-2 my-sm-0" href="{% url 'story9:login' %}">Login</a>
    {% endif %}
    </div>
  </nav>
  <div class="d-flex justify-content-center my-3">
  {% if not request.user.is_authenticated %}
    <div class="border-right pr-2 mr-2">
      <h1 class="text-light">Spellbook</h1>
      <h1 class="text-light text-right">Library</h1>
    </div>
    <div class="pr-2 mr-2">
      <h3 class="text-light" style="max-width:30rem">Database
        provided by GoogleApi.
        made by Ahmad Haydar Alkaf for Story 8.</h3>
    {% elif request.user.is_authenticated %}
      <h3 class="text-light" style="max-width:30rem">Welcome {{request.user.username}}</h3>
    {% endif %}
    </div>
  </div>

  <div class="d-flex flex-column" id="results">

  </div>
  <!-- Optional JavaScript -->
  <!-- jQuery first, then Popper.js, then Bootstrap JS -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
  <script src="{% static 'story8/searchengine.js' %}"></script>
</body>
</html>

story9/templates/story9/login.html
<!doctype html>
{% load static %}
<html lang="en">

<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

  <!-- Bootstrap CSS -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <link href="https://fonts.googleapis.com/css2?family=Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap"
          rel="stylesheet">
  <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" />
  <link rel="stylesheet" href="{%static 'story8/animations.css'%}"/>
  <title>BookSearch</title>
</head>

<body>
<nav class="shadow navbar navbar-expand-lg navbar-dark justify-content-between sticky-top" style="background-color:rgba(39,54,74,0.2)">
    <a class="navbar-brand text-light" href="{% url 'story8:index' %}" >Spellbook Library</a>
  </nav>
<section class="main-section d-flex justify-content-center align-items-center text-dark" style="height: 100vh;">
    <form method="POST" action="{% url 'story9:login' %}" class="login-form bg-light rounded-lg d-flex flex-column justify-content-center p-4">
        {% if error %}
            <p class="text-center p-2 bg-danger rounded-lg">{{error}}</p>
        {% endif %}
        <h3 class="mb-3 text-center">Login</h3>
        {% csrf_token %}
        {{login}}
        <button id="btn_login" type="submit" class="btn btn-dark" style="padding: 10px 30px; border:none; border-radius:100px 100px 100px 100px">Login</button>
        <div class="card-footer">
            <div class="d-flex justify-content-center links">
                Haven't made an account?<a class="ml-1" href="{% url 'story9:register' %}">Register!</a>
            </div>
        </div>
    </form>
</section>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script src="{% static 'story8/searchengine.js' %}"></script>
</body>
</html>

story9/templates/story9/register.html
<!doctype html>
{% load static %}
<html lang="en">

<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

  <!-- Bootstrap CSS -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <link href="https://fonts.googleapis.com/css2?family=Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap"
          rel="stylesheet">
  <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" />
  <link rel="stylesheet" href="{%static 'story8/animations.css'%}"/>
  <title>BookSearch</title>
</head>

<body>
<nav class="shadow navbar navbar-expand-lg navbar-dark justify-content-between sticky-top" style="background-color:rgba(39,54,74,0.2)">
    <a class="navbar-brand text-light" href="{% url 'story8:index' %}" >Spellbook Library</a>
  </nav>
<section class="registration-section d-flex justify-content-center align-items-center text-dark flex-column" style="height: 100vh;">
    {% if error %}
            <p class="text-center p-2 bg-danger rounded-lg">
                {{error}}
            </p>
            <p class="text-center p-2 bg-danger rounded-lg">
                * Password must be at least 9 Characters<br>
                * there must be at least 5 Letters<br>
                * it must include at least 1 Capital Letter and 1 Number
            </p>
    {% endif %}
    <form method="POST" action="{% url 'story9:register' %}" class="login-form bg-light rounded-lg d-flex flex-column justify-content-center p-4">
        <h3 class="text-center mb-3">Register</h3>
        {% csrf_token %}
        {{registering}}
        <button type="submit" id="btn_register" class="btn btn-dark" style="padding: 10px 30px; border:none; border-radius:100px 100px 100px 100px">Register</button>
    </form>

</section>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script src="{% static 'story8/searchengine.js' %}"></script>
</body>
</html>